c			 Computer Program ADD
c                             January, 2016

c			     by A. Ghali
c		       Professor of Civil Engineering
c			  The University of Calgary
c			   Calgary, Canada T2N 1N4

c		 Addition or subtraction of two matrices
c  Based on Ghali,A., Neville,A. M., Structural Analysis :A Unified Classical
c  and Matrix Approach, CRC Press, Spon Press, 7th edition, 2016,Section A-3

c      Find the sum: [C]=d1[A] +d2[B]

c      Dimensions:   [A]nm ; [B]nm ; d1 and d2 are scalors.

c   Input data instructions:

c   The input file must be named ADD.IN . Give n, m, and the real
c   multipliers d1 and d2 in one line. Give rows of [A], starting a new
c   line for each row. Do the same for [B].

c   To run the program, type 'ADD' and press enter. The result will be in a
c   file named ADD.OUT .
c_________________________________________________________________________     

c		 Listing of program ADD

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(MAXQ=20000)
      COMMON/REALV/Q(MAXQ)

      CHARACTER * 76 TITLE

      OPEN(5,FORM='FORMATTED',MODE='READ',FILE='ADD.IN')
      OPEN(6,FORM='FORMATTED',MODE='WRITE',FILE='ADD.OUT')
      DO 70 I=1,MAXQ
70    Q(I)=0.0

      READ(5,101)TITLE
101   FORMAT(A76)
      WRITE(6,200)TITLE
200   FORMAT(1X,A76)

      READ(5,*)N,M,d1,d2
      WRITE(6,100)N,M,d1,d2
100   FORMAT(3X,
     +	  'Find sum:[C]=d1[A]+d2[B];dim. [A]or[B]:(',
     +	   I2,',',I2,');d1=',E11.5,';d2=',E11.5)
c     Elements of {Q} at which real arrays start are:
c     [A]:N1 [B]:N2  [C]:N3
      N1=1
      N2=N1+N*M
      N3=N2+N*M
      CALL DATA(Q(N1),Q(N2),N,M)
      CALL ADDTN(Q(N1),Q(N2),Q(N3),N,M,d1,d2)
      CLOSE(5)
      CLOSE(6)
      STOP
      END

      SUBROUTINE DATA(A,B,N,M)
c     Reading input matrices
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(N,M),B(N,M)
      WRITE(6,100)
100   FORMAT(/,3X,'Matrix [A]:')
      DO 10 I=1,N
      READ(5,*)(A(I,J),J=1,M)
10    WRITE(6,300)(A(I,J),J=1,M)
300   FORMAT(3X,2X,5(E13.5,1X))
      WRITE(6,200)
200   FORMAT(/,3X,'Matrix [B]:')
      DO 20 I=1,N
      READ(5,*)(B(I,J),J=1,M)
20    WRITE(6,300)(B(I,J),J=1,M)
      RETURN
      END

      SUBROUTINE ADDTN(A,B,C,N,M,d1,d2)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(N,M),B(N,M),C(N,M)
      DO 10 I=1,N
      DO 10 J=1,M
10    C(I,J)=d1*A(I,J)+d2*B(I,J)
      WRITE(6,400)
400   FORMAT(/,3X,'The sum matrix [C]:' )
      DO 60 I=1,N
60    WRITE(6,500)(C(I,J),J=1,M)
500   FORMAT(3X,2X,5(E13.5,1X))
      RETURN
      END
