
c			 Computer Program DETERM
c                             January, 2016

c			     by A. Ghali
c		       Professor of Civil Engineering
c			  The University of Calgary
c			   Calgary, Canada T2N 1N4

c	       Calculation of the determinant of a square matrix
c  Based on Ghali,A., Neville,A. M., Structural Analysis :A Unified Classical
c  and Matrix Approach,CRC Press, Spon Press, 7th edition, 2016, Section A-8
c                             Version 2.0

c      Find the determinant of matrix [S] of order n.
c      Dimension:   [S]nn

c      Input data instructions:
c      on first line give title, 76 characters or less.l

c      Give n in one line. Give rows of [S], starting a new  line for
c      each row.

c      To run the program, type 'DETERM' and press enter. The result will
c      be in a file named DETERM.OUT.
c________________________________________________________________________
c		 Listing of program DETERM

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(MAXQ=20000)
      COMMON/REALV/Q(MAXQ)

      CHARACTER * 76 TITLE

      OPEN(5,FORM='FORMATTED',MODE='READ',FILE='DETERM.IN')
      OPEN(6,FORM='FORMATTED',MODE='WRITE',FILE='DETERM.OUT')
      DO 70 I=1,MAXQ
70    Q(I)=0.0

      READ(5,101)TITLE
101   FORMAT(A76)
      WRITE(6,200)TITLE
200   FORMAT(1X,A76)

      READ(5,*)N
      WRITE(6,100)N,N
100   FORMAT(3X,
     +'Calculation of the deteminant of matrix [S] of order ',I2,' x',I2
     +/,3X,'Because in structural analysis the determinate of the stiffn
     +ess matrix can be',/,3X,'very large or ',
     +'very small (in stability analysis), the natural logarithm',/,3X,
     +'of the determinate is calculated.')
c     Elements of {Q} at which real arrays start are:
c     [S]:N1
      N1=1
      CALL DATA(Q(N1),N)
      CALL DETERMINANT(Q(N1),N)
      CLOSE(5)
      CLOSE(6)
      STOP
      END

      SUBROUTINE DATA(S,N)
c     Reading input matrix
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION S(N,N)
      WRITE(6,100)
100   FORMAT(/,3X,'The given matrix:')
      DO 10 I=1,N
      READ(5,*)(S(I,J),J=1,N)
10    WRITE(6,300)(S(I,J),J=1,N)
300   FORMAT(3X,2X,5(E13.5,1X))
      RETURN
      END

      SUBROUTINE DETERMINANT(S,N)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION S(N,N)
c     Perform Gauss elimination to transform the matrix [S] into upper
c     triangular form. The product of the elements on the diagonal of the
c     transformed matrix is equal to the deteminant. Reference: Cook,R. D.,
c     Malkus, D. S. and Plesha, M. E., "Concepts and Applications of the Finite
c     Element Analysis',J. Wiley, New York, 3rd. ed.,1989, p. 593.
c     Generation of auxiliary matrix and store it in [A] and [B]
c     First row of auxiliary matrix
      DO 10 I=2,N
      DO 10 J=I,N
      C=S(J,I-1)/S(I-1,I-1)
      DO 10 K=1,N
10    S(J,K)=S(J,K)-C*S(I-1,K)



      write(6,34)(s(i,i),i=1,n)
34    format(/,' Diagonal:',3(E18.10,1x))
      rminant=1.
      do 33 i=1,N
33    rminant=rminant*S(i,i)
      write(6,35)rminant
35    format(/,'Determinant= ',e18.10)



      DETLN=0.D0
      DO 20 I=1,N
20    DETLN=DETLN+DLOG(S(I,I))
      WRITE(6,100)DETLN
100   FORMAT(/,3X,'Natural logarithm of the determinant=',E16.9)
      RETURN
      END
