c			 Computer Program MULTIPLY
c                              January, 2016 

c                              by A. Ghali
c		       Professor of Civil Engineering
c			  The University of Calgary
c			   Calgary, Canada T2N 1N4

c                     Multiplication of two matrices
c  Based on Ghali,A., Neville,A. M., Structural Analysis :A Unified Classical
c  and Matrix Approach, CRC Press, Spon Press,7th ed. 2016, Section A-5

c  Program MULTIPLY5 gives product of up to five matrices; one of the five
c  may be transposed. The present file is FORTRAN code for program MULTIPLY.
c  Program MULTIPLY calculates the product of only two matrices: 

c       [A]nm [B]mk= [C]nk

c      Input data instuctions:
c      The first line of file MULTIPLY.IN contains a title of 76 characters
c      or less.
c      Give n, m and k in one line. Give rows of [A], starting a new line
c      for each row. Do the same for [B].

c      To run the program, type 'MULTIPLY' and press enter. The result will
c      be in a file named MULTIPLY.OUT .
c___________________________________________________________________________

c      Multiply:  [A][B]=[C]
c      Dimensions:   [A]nm   ;[X]mk ; [B]nk


c		 Listing of program MUTIPLY

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(MAXQ=20000)
      COMMON/REALV/Q(MAXQ)

      CHARACTER * 76 TITLE

      OPEN(5,FORM='FORMATTED',MODE='READ',FILE='MULTIPLY.IN')
      OPEN(6,FORM='FORMATTED',MODE='WRITE',FILE='MULTIPLY.OUT')
      DO 70 I=1,MAXQ
70    Q(I)=0.0

      READ(5,101)TITLE
101   FORMAT(A76)
      WRITE(6,200)TITLE
200   FORMAT(1X,A76)


      READ(5,*)N,M,K
      WRITE(6,100)N,M,M,K
100   FORMAT(3X,
     +	  'Multiply:[A][B]=[C]; dimensions: A(',
     +	   I2,',',I2,')  ,B(',I2,',',I2,')')
c     Elements of {Q} at which real arrays start are:
c     [A]:N1 [B]:N2  [C]:N3
      N1=1
      N2=N1+N*M
      N3=N2+M*K
      CALL DATA(Q(N1),Q(N2),N,M,K)
      CALL MULT(Q(N1),Q(N2),Q(N3),N,M,K)
      CLOSE(5)
      CLOSE(6)
      STOP
      END

      SUBROUTINE DATA(A,B,N,M,K)
c     Reading input matrices
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(N,M),B(M,K)
      WRITE(6,100)
100   FORMAT(/,3X,'Matrices to be multiplied:',/,3X,'Matrix [A]:')
      DO 10 I=1,N
      READ(5,*)(A(I,J),J=1,M)
10    WRITE(6,300)(A(I,J),J=1,M)
300   FORMAT(3X,2X,5(E13.5,1X))
      WRITE(6,200)
200   FORMAT(/,3X,'Matrix [B]:')
      DO 20 I=1,M
      READ(5,*)(B(I,J),J=1,K)
20    WRITE(6,300)(B(I,J),J=1,K)
      RETURN
      END

      SUBROUTINE MULT(A,B,C,N,M,K)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(N,M),B(M,K),C(N,K)
      DO 10 I=1,N
      DO 10 J=1,K
      SUM=0
      DO 20 L=1,M
20    SUM=SUM+A(I,L)*B(L,J)
10    C(I,J)=SUM
      WRITE(6,400)
400   FORMAT(/,3X,'The product matrix [C]:' )
      DO 60 I=1,N
60    WRITE(6,500)(C(I,J),J=1,K)
500   FORMAT(3X,2X,5(E13.5,1X))
      RETURN
      END
