c                        Computer Program MULTIPLY5
c                              January,2016

c                              by A. Ghali
c                   Professor Emeritus,University of Calgary
c			   Calgary, Canada T2N 1N4

c                     Multiplication of up to five matrices

c  Companion of Ghali and Neville,Structural Analysis:A Unified Classical
c  and Matrix Approach,CRC Press, Spon Press, 7th ed., 2016.

c  Program MULTIPLY5 gives the product of up to five matrices:
c  [P1]= [M1] [M2];[P2]= [P1] [M3];[P3]= [P2] [M4];[P4]= [P3] [M5]
c  A matrix may be transposed before  multiplication. 


c  Input data instuctions:

c  Title maximum 70 characters.
c  Integer Nmats, number of matrices to be multiplied.
c  (2xNmats) integers specifying sizes of marices m1,m2,...
c  Mtrans, an  integer specifying a matrix to be transposed; enter an
c          intiger greater than 5 when none is to be transposed.

c  Rows of [M1].
c  Rows 0f [M2].
c  Rows 0f [M3]. Omit when Nmats < 3.
c  Rows 0f [M4]. Omit when Nmats < 4.
c  Rows 0f [M2]. Omit when Nmats < 5.
      

c  To run the program, type 'MULTIPLY5' and press enter. The result will
c  be in a file named MULTIPLY.OUT.
c  Note: two integers specify the size of each matrix; e.g. m3  m4 specify
c  that  without transpose, [M2] has m3 rows and m4 columns.
c___________________________________________________________________________


c     Code of Program MULTIPLY5

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(MAXQ=20000)
      PARAMETER(MAXNI=6)
      COMMON/REALV/Q(MAXQ)
      COMMON/NINTGR/Msize(20)
      COMMON/STDAT1/Nmats,Mtrans
      CHARACTER * 76 TITLE

      OPEN(5,FORM='FORMATTED',MODE='READ',FILE='MULTIPLY5.IN')
      OPEN(6,FORM='FORMATTED',MODE='WRITE',FILE='MULTIPLY5.OUT')

      DO 10 I=1,MAXQ
10    Q(I)=0.0

      DO 20 I=1,20
20    Msize(I)= 0

      read(5,100)title
100   format(A76)
      write(6,9)title
9     format(1x,A76)


c      READ(5,100)TITLE
c100   FORMAT(A76)
c      WRITE(6,200)TITLE
c200   FORMAT(3X,A76)

      READ(5,*)Nmats
      IF(Nmats.GT.5)Nmats= 5

      WRITE(6,300)Nmats
300   FORMAT(/,1X,'Number of matrices to be multiplied (maximum 5)=',I5)



      READ(5,*)(Msize(J),J=1,2*Nmats)
      WRITE(6,400)(Msize(J),J=1,2*Nmats)
400   FORMAT(/,1X,'Sizes of given matrices:',/,/,3X,
     *5(I3,I3,5X ) )

      READ(5,*)Mtrans
      WRITE(6,410)Mtrans
410   FORMAT(/,1X,'Transpose matrix number',I2,  
     *' .',/,1X,
     * ' A number>5 means that no matrix is transposed.')


c-----Genarate sizes of matrices after the transpose of matrix Mtrans.
c-----Store these sizes in {Msize} between element 11 and 20.

c     Copy the sizes in the input in elements 11 to 20 of{Msize}
      DO 51 J=1, 10
51    Msize(10+J)=Msize(J)

      IF(Mtrans.GT.5) THEN
      WRITE(6,417)(Msize(J),J=11,(2*Nmats+10))
417   FORMAT(/,1X,'Sizes of matrices to be multiplied:',/,/,3X,
     *5(I3,I3,5X ) )
      ENDIF

c---- Change elements 11 to 20  to matching sizes after transpose.    

      IF(Mtrans.EQ.1) THEN
      Msize(11)= MSize(2)
      MSize(12)= MSize(1)
      ENDIF
 
      IF(Mtrans.EQ.2) THEN
      Msize(13)= MSize(4)
      MSize(14)= MSize(3)
      ENDIF

      IF(Mtrans.EQ.3) THEN
      Msize(15)= MSize(6)
      MSize(16)= MSize(5)
      ENDIF

      IF(Mtrans.EQ.4) THEN
      Msize(17)= MSize(8)
      MSize(18)= MSize(7)
      ENDIF

      IF(Mtrans.EQ.5) THEN
      Msize(19)= MSize(10)
      MSize(20)= MSize(9)
      ENDIF


c-----Now the sizes in elements 1 to 10 are as input; while 11 to 20
c-----are matching sizes after the transpose. 


      WRITE(6,416)(Msize(J),J=11,(2*Nmats+10) )
416   FORMAT(/,3X,'Sizes of matrices to be mutiplied:',/,3X,
     *5(I3,I3,5X ) )
   
c----- Are the sizes ofconsecutive matrices matching?


      NERROR= 0
      IF(Msize(12).NE.Msize(13))THEN
      NERROR= NERROR+1
      WRITE(6,418)
418   FORMAT('ERROR: miss-matching sizes of matrices 1 and 2')
      ENDIF

      IF(Nmats.LE.2) GO TO 4190
      IF(Msize(14).NE.Msize(15))THEN
      NERROR=NERROR+1
      WRITE(6,419)
419   FORMAT('ERROR: miss-matching sizes of matrices 2 and 3')
      ENDIF

      IF(Nmats.LE.3) GO TO 4190
      IF(Msize(16).NE.Msize(17))THEN
      NERROR=NERROR+1
      WRITE(6,420)
420   FORMAT('ERROR: miss-matching sizes of matrices 3 and 4')
      ENDIF

      IF(Nmats.LE.4) GO TO 4190
      IF(Msize(18).NE.Msize(19))THEN
      NERROR=NERROR+1
      WRITE(6,421)
421   FORMAT('ERROR: miss-matching sizes of matrices 4 and 5')
      ENDIF

4190  CONTINUE

530   IF(NERROR.GE.1) GO TO 99



c     Elements of {Q} at which real arrays start are:
c     [AM1]:N1  [AM2]:N2   [AM3]:N3  [AM4]:N4  [AM5]:N5 [P1]:N6 [P2]:N7
c     [P3]:N8 [P4]:N9       Up to five matrices AM1 to AM5.

      N1=1
      N2=N1+Msize(1)* Msize(2)
      N3=N2+Msize(3)* Msize(4)
      N4=N3+Msize(5)* Msize(6)
      N5=N4+Msize(7)* Msize(8)

      N6=N5+Msize(9)* Msize(10)
      N7=N6+Msize(1)*Msize(4)
      N8=N7+Msize(1)*Msize(6)
      N9=N8+Msize(1)*Msize(8)

      N10=N9+Msize(1)*Msize(10)

c      N11=N10+ Msize(2*Mtrans+9)*Msize(2*Mtrans+10)


      CALL DATA(Q(1),Q(N2),Q(N3),Q(N4),Q(N5),Msize,Nmats,Mtrans,Q(N10))

c-----Now the transposed matrix, if  any, is stored in Q(N10); its size
c     is equal to:
c     KK= Msize(2*Mtrans+9)*Msize(2*Mtrans+10)
c     For verification, let subroutine DATA write the transposed matrix. 


      KK= Msize(2*Mtrans+9)*Msize(2*Mtrans+10)

c     Replace the elements of {Q} by the elements of the transposed matrix.

      IF(Mtrans.EQ.1)Then
      DO 11 I=1, KK
11    Q(N1+I-1)=Q(N10+I-1)
      Msize(1)=Msize(11)
      Msize(2)=Msize(12)
      END IF

      IF(Mtrans.EQ.2)Then
      DO 12 I=1, KK
12    Q(N2+I-1)=Q(N10+I-1)
      Msize(3)=Msize(13)
      Msize(4)=Msize(14)
      END IF

      IF(Mtrans.EQ.3)Then
      DO 13 I=1, KK
      Msize(5)=Msize(15)
      Msize(6)=Msize(16)
13    Q(N3+I-1)=Q(N10+I-1)
      END IF

      IF(Mtrans.EQ.4)Then
      DO 14 I=1, KK
14    Q(N4+I-1)=Q(N10+I-1)
      Msize(7)=Msize(17)
      Msize(8)=Msize(18)

      END IF

      IF(Mtrans.EQ.5)Then
      DO 15 I=1, KK
      Msize(9)=Msize(19)
      Msize(10)=Msize(20)
15    Q(N5+I-1)=Q(N10+I-1)
      END IF

c     Now Q(N1),Q(N2), ..., Q(N5) contains the five matrices after transpose.


      WRITE (6,600)
600   FORMAT(/,1X,'Product [P1] = [M1]  [M2]:',/)
      CALL MULT(Q(N1),Q(N2),Q(N6),Msize(1),Msize(2),Msize(4))


      IF(Nmats.LE.2)GO TO 59
      WRITE (6,601)
601   FORMAT(/,1X,'Product [P2] = [P1]  [M3]:',/)
      CALL MULT(Q(N6),Q(N3),Q(N7),Msize(1),Msize(4),Msize(6))

      IF(Nmats.LE.3)GO TO 59
      WRITE (6,602)
602   FORMAT(/,1X,'Product [P3] = [P2]  [M4]:',/)
      CALL MULT(Q(N7),Q(N4),Q(N8),Msize(1),Msize(6),Msize(8))

      IF(Nmats.LE.4)GO TO 59
      WRITE (6,603)
603   FORMAT(/,1X,'Product [P4] = [P3]  [M5]:',/)
      CALL MULT(Q(N8),Q(N5),Q(N9),Msize(1),Msize(8),Msize(10))

59    CONTINUE
c------
99    CONTINUE
      CLOSE(5)
      CLOSE(6)
      STOP
      END


      SUBROUTINE DATA(AM1,AM2,AM3,AM4,AM5,Msize,Nmats,Mtrans,TM)
c     Reading input matrices
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION Msize(10)

      DIMENSION AM1(Msize(1),Msize(2))
      DIMENSION AM2(Msize(3),Msize(4)) 
      DIMENSION AM3(Msize(5),Msize(6)) 
      DIMENSION AM4(Msize(7),Msize(8)) 
      DIMENSION AM5(Msize(9),Msize(10))

      DIMENSION TM(Msize(2*Mtrans+9), Msize(2*Mtrans+10) )

      I1=Msize(2*Mtrans+9)
      J1=Msize(2*Mtrans+10)

      Do 4 I=1,I1
      DO 4 J=1,J1
4     TM (I,J)= 0.
                             

      K= 0

c------ [TM] is the transposed matrix.


      K=K+1
      WRITE(6,100)
100   FORMAT(/,1X,'Input Matrix [M1]:',/)
      DO 10 I=1,Msize(2*K-1)
      READ(5,*)(AM1(I,J),J=1,Msize(2*K) )
10    WRITE(6,101)(AM1(I,J),J=1,Msize(2*K) )
101   FORMAT(1X,5(E14.6,1X))

      K=K+1
      WRITE(6,900)
900   FORMAT(/,1X,'Input Matrix [M2]:',/)
      DO 11 I=1,Msize(2*K-1)
      READ(5,*)(AM2(I,J),J=1,Msize(2*K) )
11    WRITE(6,101)(AM2(I,J),J=1,Msize(2*K) )

      K=K+1
      IF(Nmats.EQ.2)GO TO 30

      IF(Nmats.GT.2)THEN
      WRITE(6,800)
800   FORMAT(/,1X,'Input Matrix [M3]:',/)
      DO 12 I=1,Msize(2*K-1)
      READ(5,*)(AM3(I,J),J=1,Msize(2*K) )
12    WRITE(6,101)(AM3(I,J),J=1,Msize(2*K) )
      ENDIF

      K=K+1
      IF(K.EQ.3)GO TO 30

      IF(Nmats.GT.3)THEN
      WRITE(6,700)
700   FORMAT(/,1X,'Input Matrix [M4]:',/)
      DO 13 I=1,Msize(2*K-1)
      READ(5,*)(AM4(I,J),J=1,Msize(2*K) )
13    WRITE(6,101)(AM4(I,J),J=1,Msize(2*K) )
      ENDIF

      K=K+1
      IF(K.EQ.4)GO TO 30

      IF(Nmats.GT.4)THEN
      WRITE(6,600)
600   FORMAT(/,1X,'Input Matrix [M5]:',/)
      DO 14 I=1,Msize(2*K-1)
      READ(5,*)(AM5(I,J),J=1,Msize(2*K) )
14    WRITE(6,101)(AM5(I,J),J=1,Msize(2*K) )
      ENDIF

30    CONTINUE

c----- Generate the transposed matrix [TM], only when there is one.


      IF(Mtrans.GT.5 ) GO TO 301
      K=0
c-----
      K=K+1
      IF (K.EQ.Mtrans)THEN            
      DO 21 I=1,Msize(2*K+9)
      DO 21 J=1,Msize(2*K+10)
21    TM(I,J) = AM1(J,I)
      ENDIF
c------


      K=K+1
      IF (K.EQ.Mtrans)THEN            
      DO 31 I=1,Msize(2*K+9)
      DO 31 J=1,Msize(2*K+10)
31    TM(I,J) = AM2(J,I)
      ENDIF
c------
      K=K+1
      IF (K.EQ.Mtrans)THEN            
      DO 41 I=1,Msize(2*K+9)
      DO 41 J=1,Msize(2*K+10)
41    TM(I,J) = AM3(J,I)
      ENDIF
c-----
      K=K+1
      IF (K.EQ.Mtrans)THEN            
      DO 51 I=1,Msize(2*K+9)
      DO 51 J=1,Msize(2*K+10)
51    TM(I,J) = AM4(J,I)
      ENDIF
c-----

      K=K+1
      IF (K.EQ.Mtrans)THEN            
      DO 61 I=1,Msize(2*K+9)
      DO 61 J=1,Msize(2*K+10)
61    TM(I,J) = AM5(J,I)
      ENDIF


301    Continue



c-----Now, we write the transposed matrix.

      

      IF(Mtrans.LE.5)THEN
      WRITE(6,141)Mtrans
141   FORMAT(/,1X,'The transpose of Matrix M',I1,':',/)

      DO 611 I=1,I1
611   WRITE(6,101)(TM(I,J),J=1,J1)
      ENDIF
c----


      WRITE(6,32)
32    FORMAT(/,1X,'---------------------------------------------------')

      RETURN
      END

      SUBROUTINE MULT(A,B,C,N,M,K)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION A(N,M),B(M,K),C(N,K)
      DO 10 I=1,N
      DO 10 J=1,K
      SUM=0
      DO 20 L=1,M
20    SUM=SUM+A(I,L)*B(L,J)
10    C(I,J)=SUM
c      WRITE(6,400)
c400   FORMAT(/,3X,'The product matrix [C]:',/ )
      DO 60 I=1,N
60    WRITE(6,500)(C(I,J),J=1,K)
500   FORMAT(1X,5(E14.6,1X))
      RETURN
      END

